//+------------------------------------------------------------------+
//|                                                ryan_jones_sm.mq4 |
//|                                         Copyright  2007, Sergan |
//|                                                                  |
//+------------------------------------------------------------------+
//  1.0 03.11.07
// :
/* ,    ,  .  :
:
1.	  ,   "X"-  ,   ,    "Y"   .
2.	     ,    "Y"   .
3.	     ,     "Y+X"   .
    ,         

:
1.	  ,   "X"-     ,    "Y"   .
2.	     ,    "   .
3.	     ,     "Y+X"   .

,  ""= 20  "Y"=3
*/
#define LOW 0
#define HIGH 1
#define OP_NONE -1  //  -   OP_BUY, OP_SELL  ..   
#define OP_CLOSEORDER -2 //  -  
#define UP 1
#define DOWN -1
//----
#define MAGICMA  031107
#include <stdlib.mqh>
#include <WinUser32.mqh>
//----
#property copyright "Copyright  2007, Sergan"
#property link      "SerganMT@hotbox.ru"
//----
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Red
#property indicator_color2 Gold
#property indicator_color3 DarkBlue
#property indicator_color4 Black
#property indicator_color5 Blue
#property indicator_color6 Blue
//----
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 3
#property indicator_width6 3
//---- input parameters
extern int       ParY=3;  // "Y"
extern int       ParX=20; //  "X"
//---- buffers
double ExtMapBuffer1[];  //    "X"
double ExtMapBuffer2[];  //    "X"  "Y"
double ExtMapBuffer3[];  //  "Y"  
double ExtMapBuffer4[];  //  "Y+X"   
//----
double BuyBuffer[];     //  
double SellBuffer[];    //  
double BufferSignalType[]; //   ,     
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0, "ma("+ParX+")" );
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1, "ma("+ParX+","+ParY+")" );
   //----
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2, "close("+ParY+")" );
   //----
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexLabel(3, "close("+(ParY+ParX)+")" );
   //----
   SetIndexStyle( 4, DRAW_ARROW, EMPTY );
   SetIndexArrow( 4, 233 );
   SetIndexStyle( 5, DRAW_ARROW, EMPTY );
   SetIndexArrow( 5, 234 );
   //----
   SetIndexBuffer( 4, BuyBuffer   );
   SetIndexEmptyValue(4,0);
   SetIndexBuffer( 5, SellBuffer   );
   SetIndexEmptyValue(5,0);
   ArrayInitialize(BuyBuffer, 0 );
   ArrayInitialize(SellBuffer, 0 );
//----
   int drawtype=DRAW_ARROW ;
   SetIndexBuffer(6,BufferSignalType );
   SetIndexStyle( 6, DRAW_NONE);
   SetIndexEmptyValue(6,0);
   //----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  bool ShowSignals(int i  )
  {
   BuyBuffer[i]=0; SellBuffer[i]=0; BufferSignalType[i]=OP_NONE;
   int cmd=OP_NONE;
   if(i>Bars-100)return(false);
/*
double ExtMapBuffer1[];  //    "X"
double ExtMapBuffer2[];  //    "X"  "Y"
double ExtMapBuffer3[];  //  "Y"  
double ExtMapBuffer4[];  //  "Y+X"   

:
1.	  ,   "X"-     ,    "Y"   .
2.	     ,    "   .
3.	     ,     "Y+X"   .

:
1.	  ,   "X"-  ,   ,    "Y"   .
2.	     ,    "Y"   .
3.	     ,     "Y+X"   .
    ,         
*/
     if(ExtMapBuffer1[i]<ExtMapBuffer2[i])
     {
        if(Close[i]>ExtMapBuffer3[i] && Close[i] <  ExtMapBuffer4[i])
        {
         cmd=OP_SELL;
         SellBuffer[i]= Close[i];
        }
     }
     if(ExtMapBuffer1[i]>ExtMapBuffer2[i])
     {
        if(Close[i]<ExtMapBuffer3[i] && Close[i] >  ExtMapBuffer4[i])
        {
         cmd=OP_BUY;
         BuyBuffer[i]= Close[i];
        }
     }
   BufferSignalType[i]=cmd;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  int start()
  {
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0)  return(-1);
   if(counted_bars > 0)   counted_bars--;
   int limit = Bars - counted_bars;
   if(counted_bars==0) limit-=1+ParY+ParX;
   
     for( int i=limit; i>0; i -- )
     {
      ExtMapBuffer1[i]=iMA(NULL,0,ParX,0,MODE_SMA,PRICE_CLOSE,i);
      ExtMapBuffer2[i]=iMA(NULL,0,ParX,ParY,MODE_SMA,PRICE_CLOSE,i);
      ExtMapBuffer3[i]=Close[ParY+i]; //  Y  
      ExtMapBuffer4[i]=Close[ParY+ParX+i];//  "Y+X"   
      ShowSignals(i);
     }
   return(0);
  }
//+------------------------------------------------------------------+